--
-- Script for Sipma Z-274/1 bale wrapper
--
-- By Koper
--
-- Date : 20.06.2011
--

sipma = {}

function sipma.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function sipma:load(xmlFile)

	self.stol = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.owijarka#stol"));
	self.platforma = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.owijarka#platforma"));
	self.baleAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.owijarka#zaczepBeli"));
	self.walek1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.owijarka#walek1"));
	self.walek2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.owijarka#walek2"));
	self.trigger = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.owijarka#trigger"));
	self.iloscObrotowDoKonca = 21
	self.attachedBale = nil
	self.baleInRange = nil
	self.isReadyToWork = false
	self.obracaj = false
	self.wspolczynnikObrotu = Utils.getNoNil(getXMLString(xmlFile, "vehicle.owijarka#rotationSpeedMultiplier"), 1)
	self.iloscObrotow = 0
	self.bela1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale1#index"))
	self.bela2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale2#index"))
	self.bela3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale3#index"))
	self.bela4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale4#index"))
	self.bela5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale5#index"))
	self.bela6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale6#index"))
	self.bela7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale7#index"))
	self.bela8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale8#index"))
	self.bela9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale9#index"))
	self.bela10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bales.bale10#index"))
	self.wrappedBaleFilename = getXMLString(xmlFile, "vehicle.owijarka#wrappedBaleFilename")
	self.isReadyToUnload = false
	self.collisionLoad1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.collisions.loading#col1"))
	self.collisionLoad2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.collisions.loading#col2"))
	self.collisionUnload1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.collisions.unloading#col1"))
	self.collisionUnload2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.collisions.unloading#col2"))
	self.sipma = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.owijarka#sipma"))
	
end;

function sipma:delete()
end;

function sipma:mouseEvent(posX, posY, isDown, isUp, button)
end;

function sipma:keyEvent(unicode, sym, modifier, isDown)
end;

function sipma:draw()
end;

function sipma:update(dt)

	if self:getIsActive() then
		
		addTrigger(self.trigger, "baleInTrigger", sipma)

		if baleInRange ~= nil then
		    self.isAbleToAttach = true
	    	if self.attachedBale == nil then
				g_currentMission:addExtraPrintText("KP_0: Ballen attachen")
			end;
		elseif baleInRange == nil then
	    	self.isAbleToAttach = false
	    	if self.attachedBale == nil then
	    		g_currentMission:addExtraPrintText("KP_3: Teller drehen")
	    		g_currentMission:addExtraPrintText("KP_0: Ballen aufladen zum Wickeln")
			end;
		end;
		if self.isReadyToWork == true and self.isWorking == false then
		    g_currentMission:addExtraPrintText("KP_1: Starte Wickelvorgang")
		end;
	
		if self.isAbleToAttach == true and self.attachedBale == nil then
	    	if InputBinding.hasEvent(InputBinding.zaczep) then
	    		zaczepBele(self)
			end;
		end;
		
		if self.attachedBale == nil then
			if InputBinding.hasEvent(InputBinding.obrocDoZaladunku) then
				self.rotateToLoad = true
			end;
		end; 
	
		stolrad = Utils.degToRad(0.1 * self.wspolczynnikObrotu)
		sy = 0.00135 * self.wspolczynnikObrotu
		
		pelnyObrot = Utils.degToRad(360)
		if self.isReadyToWork == true then
			if InputBinding.hasEvent(InputBinding.obracaj) then
				self.obracaj = not self.obracaj
			end;
		end;
		stx, sty, stz = getRotation(self.stol)
	
		if self.rotateToLoad == true then
			rotate(self.stol, 0, -1*stolrad*dt, 0)
		end;
		if sty <= Utils.degToRad(-90) then
			self.rotateToLoad = false
		end;
	
		if self.obracaj == true then
		    self.isWorking = true
			if sty < 21*pelnyObrot then
				rotate(self.stol, 0, stolrad*dt, 0)
				rotate(self.baleAttacher, 0, 0, stolrad/21*dt)
			end;
		end;
		if sty >= pelnyObrot and sty < 2*pelnyObrot then
			rotationEvent(self)
		elseif sty >= 2*pelnyObrot and sty < 3*pelnyObrot then
			setVisibility(self.bela1, false)
			setVisibility(self.bela2, true)
		elseif sty >= 3*pelnyObrot and sty < 4*pelnyObrot then
    	    setVisibility(self.bela2, false)
    	    setVisibility(self.bela3, true)
		elseif sty >= 4*pelnyObrot and sty < 5*pelnyObrot then
    	    setVisibility(self.bela3, false)
    	    setVisibility(self.bela4, true)
		elseif sty >= 5*pelnyObrot and sty < 6*pelnyObrot then
    	    setVisibility(self.bela4, false)
    	    setVisibility(self.bela5, true)
		elseif sty >= 6*pelnyObrot and sty < 7*pelnyObrot then
   	     	setVisibility(self.bela5, false)
   	     	setVisibility(self.bela6, true)
		elseif sty >= 7*pelnyObrot and sty < 8*pelnyObrot then
   	     	setVisibility(self.bela6, false)
   	     	setVisibility(self.bela7, true)
		elseif sty >= 8*pelnyObrot and sty < 9*pelnyObrot then
        	setVisibility(self.bela7, false)
        	setVisibility(self.bela8, true)
		elseif sty >= 9*pelnyObrot and sty < 10*pelnyObrot then
        	setVisibility(self.bela8, false)
        	setVisibility(self.bela9, true)
		elseif sty >= 10*pelnyObrot then
			createWrappedBale(self)
		end;
		if sty >= 21*pelnyObrot then
			self.isReadyToUnload = true
			if self.startUnloadPhase1 == false or self.startUnloadPhase1 == nil then
			    g_currentMission:addExtraPrintText("KP_2: Ballen abladen")
			end;
			self.obracaj = false
		end;
	
		if self.isReadyToUnload == true then
	    	if InputBinding.hasEvent(InputBinding.wyladuj) then
				self.startUnloadPhase1 = true
				self.isReadyToWork = false
			end;
		end;
	
		if self.startUnloadPhase1 == true then
	    	if sty < 21.25*pelnyObrot then
	        	rotate(self.stol, 0, stolrad*dt, 0)
			end;
			if sty >= 21.25*pelnyObrot then
		    	self.startUnloadPhase1 = false
		    	self.startUnloadPhase2 = true
		    	setCollisionMask(self.collisionUnload1, 00000001000000000000000000000000)
		    	setCollisionMask(self.collisionUnload2, 00000001000000000000000000000000)
		    	setCollisionMask(self.collisionLoad1, 00000000000000000000000000000000)
		    	setCollisionMask(self.collisionLoad2, 00000000000000000000000000000000)
			end;
		end;
	
		prx, pry, prz = getRotation(self.platforma)
		ppx, ppy, ppz = getTranslation(self.sipma)
	
		if self.startUnloadPhase2 == true then
	    	if prx > Utils.degToRad(-25) then
	        	rotate(self.platforma, stolrad*-0.2*dt, 0, 0)
			end;
			if ppy < 0.6936 then
				translate(self.sipma, 0, sy*0.2*dt, 0)
			end;
			if prx <= Utils.degToRad(-25) then
		    	self.startUnloadPhase2 = false
				if self.attachedBale ~= nil then
					wbpx, wbpy, wbpz = getWorldTranslation(self.attachedBale)
					wbrx, wbry, wbrz = getWorldRotation(self.attachedBale)
					setTranslation(self.attachedBale, wbpx, wbpy, wbpz)
					setRotation(self.attachedBale, wbrx, wbry, wbrz)
					root = getRootNode()
					link(root, self.attachedBale)
					g_currentMission:addItemToSave(Utils.getFilename(self.wrappedBaleFilename, self.baseDirectory), self.attachedBale, 0)
					setRigidBodyType(self.attachedBale, "Dynamic")
					self.attachedBale = nil
				end;
   				timerId = addTimer(3000, "onTimer", sipma)
			end;
		end;
	
		if startUnloadPhase3 == true then
	    	if prx ~= 0 then
	        	rotate(self.platforma, stolrad*0.2*dt, 0, 0)
			end;
			if ppy > 0.35594 then
				translate(self.sipma, 0, sy*-0.2*dt, 0)
			end;
			if ppy <= 0.35594 then
				setTranslation(self.sipma, 0, 0.35594, 0)
			end;
			if prx >= 0 then
		    	startUnloadPhase3 = false
		    	self.startUnloadPhase4 = true
			end;
		end;
	
		if self.startUnloadPhase4 == true then
	    	if sty > 21*pelnyObrot then
	        	rotate(self.stol, 0, stolrad*-1*dt, 0)
			end;
			if sty <= 21*pelnyObrot then
		    	setRotation(self.stol, 0, 0, 0)
		    	self.startUnloadPhase4 = false
		    	unloadBale = false
		    	setCollisionMask(self.collisionUnload1, 00000000000000000000000000000000)
		    	setCollisionMask(self.collisionUnload2, 00000000000000000000000000000000)
		    	setCollisionMask(self.collisionLoad1, 00000001000000000000000000000000)
		    	setCollisionMask(self.collisionLoad2, 00000001000000000000000000000000)
		    	self.isReadyToUnload = false
		    	self.isWorking = false
			end;
		end;
	end;
end;

function sipma:baleInTrigger(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)

	if onEnter or onStay then
		if getUserAttribute(otherId, "isRoundHaybale") then
		    baleInRange = otherId
	end;
	end;
		
	if onLeave then
	    if baleInRange ~= nil then
	        baleInRange = nil
		end;
	end;
	
end;


function zaczepBele(self)

	hbry = Utils.degToRad(90)
	hbrz = Utils.degToRad(18)
    link(self.baleAttacher, baleInRange);
	setRigidBodyType(baleInRange, "NoRigidBody");
	setTranslation(baleInRange, 0, 0, 0);
	setRotation(baleInRange, 0, hbry, hbrz);
	self.attachedBale = baleInRange
	self.isReadyToWork = true
	
end;

function rotationEvent(self)
	if self.attachedBale ~= nil and self.attachedBale ~= "noBale" then
    	unlink(self.attachedBale)
	    delete(self.attachedBale)
	    g_currentMission:removeItemToSave(self.attachedBale)
	    self.attachedBale = "noBale"
	    setVisibility(self.bela1, true)
	end;
end;

function createWrappedBale(self)

	if self.attachedBale == "noBale" then
		setVisibility(self.bela9, false)
		local wrappedBaleRoot = Utils.loadSharedI3DFile(self.wrappedBaleFilename, self.baseDirectory)
		local wrappedBaleId = getChildAt(wrappedBaleRoot, 0)
		self.attachedBale = wrappedBaleId
		setRigidBodyType(self.attachedBale, "NoRigidBody")
		link(self.baleAttacher, self.attachedBale)
		setTranslation(self.attachedBale, 0, 0, 0)
		setRotation(self.attachedBale, 0, hbry, 0)
	end;
	
end;

function sipma:onTimer()

	startUnloadPhase3 = true
	
	return false
end;
	
	
	